# -*- perl -*-

package Bundle::BBBike;

$VERSION = sprintf("%d.%02d", q$Revision: 1.3 $ =~ /(\d+)\.(\d+)/);

1;

__END__

=head1 NAME

Bundle::BBBike - A bundle to install all dependencies of BBBike

=head1 SYNOPSIS

 perl -I`pwd` -MCPAN -e 'install Bundle::BBBike'

=head1 CONTENTS


Tk 800.000	- das absolute Muss!

Tk::FireButton	- "Firebutton"-Funktionalitt fr die Windrose

Tk::Pod 2.8	- Online-Hilfe

Tk::FontDialog	- zum ndern des Zeichensatzes aus dem Programm heraus

Tk::JPEG

Tie::Watch

Tk::HistEntry

Tk::Stderr	- optionales Redirect von Fehlermeldungen in ein Tk-Fenster

Tk::DateEntry 1.38

Tk::Date

Tk::PNG	- Fr Icons mit besserer Alpha-Untersttzung

Tk::NumEntry 2.06

X11::Protocol	- Rotated text support

LWP::UserAgent	- fr die WWW-Verbindungen (z.B. Wetterbericht); in der Perl/Tk-GUI empfohlen fr Daten-Updates ber das Internet (ansonsten wird Http.pm verwendet)

Image::Magick	- fr Bildmanipulationen beim Radar-Bild der FU

Apache::Session::DB_File	- optionale Session-Verwaltung fr das CGI-Programm, notwendig fr wapbbbike

Apache::Session::Counted	- optionale aber sehr zu empfehlende Session-Verwaltung fr das CGI-Programm

XML::SAX	- CPAN.pm kann XML::SAX nicht ber XML::Simple automatisch installieren

XML::Simple	- optional fr XML-Dumps der BBBike-Route

XML::LibXML	- optional fr das Parsen und Erzeugen von GPX-Dateien und fr UAProf parsing

XML::Parser	- optional fr UAProf parsing (bevorzugt wird allerdings XML::LibXML::SAX oder XML::SAX::PurePerl)

XML::Twig	- alternativ fr das Parsen und Erzeugen von GPX-Dateien, bentigt XML::Parser

YAML	- optional fr YAML-Dumps der BBBike-Route

YAML::Syck	- optional fr die Testsuite sowie fuer temp_blockings, knnte YAML.pm in Zukunft komplett ersetzen

JSON::XS	- optional fr JSON-Dumps der BBBike-Route und diverse Serialisierungsaufgaben

Kwalify	- optional fr Validierung in der Testsuite

Mail::Mailer 1.53	- falls man aus bbbike heraus E-Mails mit der Routenbeschreibung verschicken will

MIME::Lite	- Versenden von Benutzer-Kommentaren im Webinterface

String::Approx 2.7	- oder man verwendet agrep (mindestens Version 3.0)

String::Similarity	- optional fr den temp_blockings-Editor und ungenaue Suche in der Perl/Tk-Applikation

Storable	- fr das Caching beim CGI-Programm

Digest::MD5	- fr den File-Cache im CGI-Programm

MLDBM

GD 1.18	- zum On-the-fly-Erzeugen von Grafiken beim CGI-Programm

Chart::ThreeD::Pie	- Tortendiagramme in der Statistik

Algorithm::Permute 0.08	- Fr das Problem des Handlungsreisenden (schnellerer Permutor)

List::Permutor	- Fr das Problem des Handlungsreisenden (langsamerer Permutor)

PDF::Create 0.06	- Erzeugung der Route als PDF-Dokument

Cairo	- Erzeugung der Route als PDF-Dokument, alternativer Renderer

Pango	- Erzeugung der Route als PDF-Dokument, alternativer Renderer

Font::Metrics::Helvetica	- Fr die Reparatur der Zeichenbreitentabellen in PDF::Create

BSD::Resource

Devel::Peek

Statistics::Descriptive

Math::MatrixReal

Class::Accessor	- fr die ESRI-Module etc.

Template	- fr BBBikeDraw::MapServer

Inline::C	- fr den schnelleren Suchalgorithmus, siehe ext/Strassen-Inline

Pod::Usage	- fr das Ausgeben der 'Usage' in einigen Entwicklungs-Tools

Palm::PalmDoc	- fr das Erzeugen von palmdoc-Dateien mit der Routenbeschreibung

Astro::Sunrise 0.85	- Anzeige des Sonnenuntergangs/-aufgangs im Info-Fenster

WWW::Shorten	- Krzen der langen Mapserver-Links im Info-Fenster

File::ReadBackwards	- LogTracker plugin, Edititeren

Date::Pcalc	- LogTracker plugin (mgliche Alternative ist Date::Calc)

XBase	- Erzeugen der Mapserver- oder anderer ESRI-Dateien

IPC::Run	- hilft bei der sicheren Ausfhrung von externen Kommandos (insbesondere fr Win32)

Imager	- additional optional BBBikeDraw backend for PNG graphics

Imager::Screenshot	- better screenshot module

Image::ExifTool	- fr geocode_images

SVG	- additional optional BBBikeDraw backend for SVG graphics

GD::SVG 0.31	- another SVG alternative, not used yet in production

Object::Iterate	- Notwendig fr die bbd2-esri-Konvertierung

Object::Realize::Later	- Notwendig fr Strassen::Lazy, selten bentigt

Archive::Zip	- Zum Zippen der BBBike-Daten in bbbike-data.cgi

Text::CSV_XS	- Fr das Parsen des MapInfo-Formats

DBI	- Fr XBase/MySQL, siehe unten

DBD::XBase	- Fr das Parsen des ESRI-Shapefile-Formats

XBase	- Ebenfalls fr das Parsen des ESRI-Shapefile-Formats

Geo::GDAL	- Fr das Parsen des ESRI-Projection-Formats

Geo::Proj4	- Fr das Konvertieren von ESRI-Shapefiles

DBD::mysql	- Fr den Zugriff auf die Hausnummerdatenbank

Tie::IxHash	- Damit Direktiven in Straen-Daten geordnet bleiben

CDB_File	- Fr die alternative A*-Optimierung in XS/C

DB_File::Lock	- Same DB_File operations, used in Strassen::Index

GPS::Garmin	- fr GPS-Upload

Geo::SpaceManager 0.91	- Intelligentere Labelplatzierung, bei der PDF-Ausgabe verwendet

Geo::Distance::XS	- Berechnung von Entfernungen fr polare Koordinaten, mglicherweise schneller als Math::Trig

Geo::Distance 0.16	- Prereq fr Geo::Distance::XS

Geo::METAR	- Wetterdaten im METAR-Format

Tk::ExecuteCommand	- Bessere Fehlerberichte im temp_blockings-Editor

Algorithm::Diff	- Unterschiede im temp_blockings-Editor anzeigen

Sort::Naturally	- Fr natrliches Sortieren von bbd-Dateien

Geo::Coder::Googlev3	- Geocoding ber Googlemaps (API v3)

Geo::Coder::Bing 0.10	- Geocoding ber Bing

Geo::Cloudmade	- Geocoding ber Cloudmade

Geo::Coder::OSM	- Geocoding mit OpenStreetMap-Daten

Geo::Coder::PlaceFinder	- Geocoding mit Yahoo PlaceFinder

Flickr::API	- Flickr-Bilder in BBBike anzeigen

Image::Info 1.32

Test::More

Test::Differences

WWW::Mechanize	- Fr Testen des CGI-Interfaces

WWW::Mechanize::FormFiller	- Fr Testen des CGI-Interfaces

Devel::Leak	- Fr Memory-Leak-Tests

Text::Table

Text::Unidecode	- Fr das Neu-Erzeugen der .bbd-Dateien in data; Fallback fr internationale Texte in PDFs

Data::Compare	- Fr das Neu-Erzeugen der .bbd-Dateien in data

HTML::FormatText	- Fr VMZTool

Math::Round	- Fr downloadosm -round


=head1 DESCRIPTION

Dieses BE<uuml>ndel listet alle erforderlichen und empfohlenen Module
fE<uuml>r BBBike auf. Bis auf B<Tk> sind alle anderen Module optional.

This bundle lists all required and optional perl modules for BBBike.
Only B<Tk> is really required, all other modules are optional.

=head1 AUTHOR

Slaven Rezic <slaven@rezic.de>

=cut
