# -*- perl -*-

#
# $Id: Brandenburg_DE.pm,v 1.4 2005/04/29 23:37:15 eserte Exp $
# Author: Slaven Rezic
#
# Copyright (C) 2001 Slaven Rezic. All rights reserved.
# This package is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
#
# Mail: slaven@rezic.de
# WWW:  http://bbbike.sourceforge.net
#

# Das Land Brandenburg

package Geography::Brandenburg_DE;
use strict;
use vars qw(%parts %kfz);

use base qw(Geography::Base);

my $partdef =
    ['Barnim',
     ['Ahrensfelde',
      'Basdorf',
      'Bernau' => ['Birkholzaue', 'Waldsiedlung'],
      'Biesenthal',
      'Blumberg',
      'Klosterfelde',
      'Lanke',
      'Lindenberg',
      'Lobetal',
      'Mehrow-Trappenfelde',
      'Schnerlinde',
      'Schnwalde',
      'Schwanebeck' => ['Neu-Schwanebeck'],
      'Seefeld',
      'Tiefensee',
      'Wandlitz',
      'Werneuchen' => ['Stienitzaue'],
      'Zepernick',
     ],

     'Havelland',
     ['Bredow' => ['Glien'],
      'Brieselang',
      'Dallgow-Dberitz' => ['Rohrbeck'],
      'Falkensee' => ['Falkenhain', 'Finkenkrug', 'Seegefeld'],
      'Ketzin',
      'Perwenitz',
      'Priort',
      'Schnwalde' => ['Siedlung'],
      'Wustermark' => ['Dyrotz', 'Nord'],
     ],

     'Landkreis Dahme-Spree',
     ['Bestensee',
      'Dannenreich' => ['Friedrichshof'],
      'Friedersdorf',
      'Grbendorf',
      'Kablow',
      'Kiekebusch' => ['Karlshof'],
      'Knigs Wusterhausen',
      'Mittenwalde',
      'Motzen',
      'Niederlehme',
      'Ptz',
      'Prieros',
      'Schnefeld',
      'Streganz' => ['Klein Eichholz'],
      'Waltersdorf',
      'Wernsdorf',
      'Wildau',
      'Wolzig',
      'Zernsdorf',
      'Zeuthen',
     ],

     'Landkreis Oder-Spree',
     ['Alt-Stahnsdorf' => 'Neu Stahnsdorf',
      'Erkner',
      'Gosen',
      'Hangelsberg',
      'Hartmannsdorf',
      'Kagel',
      'Markgrafpieske',
      'Schneiche',
      'Spreeau',
      'Spreenhagen',
      'Woltersdorf',
     ],

     'Mrkisch Oderland',
     ['Altlandsberg',
      'Dahlwitz-Hoppegarten',
      'Fredersdorf-Vogelsdorf' => ['Fredersdorf', 'Vogelsdorf'],
      'Herzfelde',
      'Hnow',
      'Mnchehofe',
      'Neuenhagen',
      'Rehfelde',
      'Rdersdorf',
      'Strausberg',
     ],

     'Oberhavelland',
     ['Brenklau',
      'Birkenwerder',
      'Btzow' => ['West'],
      'Germendorf',
      'Gro-Ziethen',
      'Hennigsdorf' => ['Nieder Neuendorf', 'Nord', 'Stolpe-Sd'],
      'Hohen Neuendorf' => ['Bergfelde', 'Stolpe', 'Borgsdorf'],
      'Kremmen',
      'Leegebruch',
      'Lehnitz',
      'Mhlenbeck' => ['Feldheim'],
      'Oberkrmer' => ['Klein-Ziethen', 'Vehlefanz'],
      'Oranienburg' => ['Sachsenhausen', 'Eden'],
      'Schildow',
      'Schmachtenhagen',
      'Schnflie',
      'Schwante',
      'Velten' => ['Hohenschpping'],
      'Wensickendorf',
      'Zehlendorf',
      'Zhlsdorf',
     ],

     'Potsdam',
     ['Am Schlaatz',
      'Am Stern',
      'Babelsberg',
      'Berliner Vorstadt',
      'Bornim',
      'Bornstedt',
      'Brandenburger Vorstadt',
      'Drewitz',
      'Eiche',
      'Innenstadt',
      'Jger Vorstadt',
      'Kirchsteigfeld',
      'Nauener Vorstadt',
      'Nedlitz',
      'Potsdam West',
      'Sacrow',
      'Teltower Vorstadt',
      'Templiner Vorstadt',
      'Waldstadt',
      'Wildpark',
      'Zentrum Ost',
     ],

     'Potsdam-Mittelmark',
     ['Beelitz-Heilsttten',
      'Bergholz-Rehbrcke',
      'Bochow',
      'Damsdorf',
      'Derwitz',
      'Fahrland-Krampnitz',
      'Ferch',
      'Ferch-Schmerberg',
      'Fichtenwalde',
      'Geltow',
      'Golm',
      'Gro Kreutz',
      'Kleinmachnow' => ['Dreilinden'],
      'Langerwisch',
      'Lehnin',
      'Michendorf',
      'Philippsthal',
      'Phben',
      'Saarmund',
      'Satzkorn',
      'Schenkenhorst',
      'Seddiner See-Neuseddin',
      'Seeburg',
      'Stahnsdorf',
      'Teltow',
      'Tplitz' => ['Alt-Tplitz'],
      'Uetz',
      'Werder' => ['Bliesendorf', 'Pltzin'],
      'Wildenbruch',
      'Wilhelmshorst',
     ],

     'Teltow-Flming',
     ['Grobeeren',
      'Ludwigsfelde' => ['Genshagen'],
      'Siethen',
     ],

    ];

%kfz = (qw(B   Berlin
	   BAR Barnim
	   HVL Havelland
	   OHV Oberhavelland
	   P   Potsdam
	   PM  Potsdam-Mittelmark
	   TF  Teltow-Flming
	  ),
	LDS => 'Landkreis Dahme-Spree',
	LOS => 'Landkreis Oder-Spree',
	MOL => 'Mrkisch Oderland',
       );

1;

__END__
